create or replace function parse_listener_log_line
(
    p_in varchar2,
    p_param in varchar2
)
return varchar2
as
    l_begin     number(3);
    l_end       number(3);
    l_val       varchar2(2000);
begin
    if p_param not in (
            'SID',
            'SERVICE_NAME',
            'PROGRAM',
            'SERVICE',
            'HOST',
            'USER',
            'PROTOCOL',
            'TYPE',
            'METHOD',
            'RETRIES',
            'DELAY',
            'PORT',
            'COMMAND'
    ) then
        raise_application_error (-20001,'Invalid Parameter Value '
           ||p_param);
    end if;
    l_begin := instr (upper(p_in), '('||p_param||'=');
    l_begin := instr (upper(p_in), '=', l_begin);
    l_end := instr (upper(p_in), ')', l_begin);
    l_val := substr (p_in, l_begin+1, l_end - l_begin - 1);
    return l_val;
end;
/
